// WndPosDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WndPos.h"
#include "WndPosDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWndPosDlg dialog

CWndPosDlg::CWndPosDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWndPosDlg::IDD, pParent),m_wndPos(HKEY_CURRENT_USER,_T("software\\WndPos"))
{
	//{{AFX_DATA_INIT(CWndPosDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWndPosDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWndPosDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWndPosDlg, CDialog)
	//{{AFX_MSG_MAP(CWndPosDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
  ON_WM_WINDOWPOSCHANGED()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWndPosDlg message handlers

BOOL CWndPosDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	DWORD dwXPos,dwYPos,dwWidth,dwHeight;

  if(TRUE == m_wndPos.GetWindowPositions(dwXPos,dwYPos,dwWidth,dwHeight))
  {
    SetWindowPos(NULL,dwXPos,dwYPos,dwWidth,dwHeight,SWP_NOOWNERZORDER | SWP_NOZORDER|SWP_NOSIZE);
  }
  else
    CenterWindow();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWndPosDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWndPosDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWndPosDlg::OnWindowPosChanged( WINDOWPOS* lpwndpos )
{
  m_wndPos.OnWindowPosChanged(lpwndpos);
  m_wndPos.SaveWindowPositions();
}
