// WindowPosition.h: interface for the WindowPosition class.
//
//////////////////////////////////////////////////////////////////////
#ifndef _WINDOW_POSITION_H_
#define _WINDOW_POSITION_H_

#include "windows.h"
#include "tchar.h"

class WindowPosition  
{
public:
	WindowPosition(HKEY hKey,TCHAR* szSubKey);
	virtual ~WindowPosition();

private:
  DWORD m_dwPosArray[5];
  HKEY  m_hKey;
  TCHAR m_szSubKey[MAX_PATH];

  BOOL ValidatePositions(DWORD& dwxPos,DWORD& dwyPos,DWORD& dwWidth,DWORD& dwHeight,DWORD& dwSum);

public:
  BOOL GetWindowPositions(DWORD& dwxPos,DWORD& dwyPos,DWORD& dwWidth,DWORD& dwHeight);
  void OnWindowPosChanged(WINDOWPOS* lpwndpos);
  BOOL SaveWindowPositions();
};

#endif // _WINDOW_POSITION_H_
